unit eBob42.NiceLabelControl;
// To create a more advanced Web Control that supports live data at
// design time, see instructions in the readme file located in the
// 'BDS\3.0\Source\dotNet\dbwebcontrols' directory

interface

uses
  System.Web.UI, System.Web.UI.WebControls,
  System.ComponentModel;

type
  /// <summary>
  /// Summary description for MyWebControl1.
  /// </summary>
  [DefaultProperty('Text'),
   ToolboxData('<{0}:NiceLabelControl runat=server></{0}:NiceLabelControl>')]
  NiceLabelControl = class(System.Web.UI.Control)
  strict private
    FText: String;
  strict protected
   // override Render(..) when you inherit from Web.UI.Control
   procedure Render(Output: HtmlTextWriter); override;
  public
    constructor Create;
  published
    [Bindable(true),
     Category('Appearance'),
     DefaultValue('')]
    property Text: string read FText write FText;
  end;

implementation

/// <summary>
/// Define a public parameterless constructor needed by web controls.
/// </summary>
constructor NiceLabelControl.Create;
begin
  inherited;
end;

{$REGION 'Render override'}
/// <summary>
/// Render this control to the output parameter specified.
/// </summary>
/// <param name="output"> The HTML writer to write out to </param>
procedure NiceLabelControl.Render(Output: HtmlTextWriter);
begin
  Output.Write('<b>' + Text + '</b>');
end;
{$ENDREGION}

end.
