unit eBob42.DBWebNicerLabel;
interface
  uses System.Web.UI, System.Web.UI.WebControls,
  System.ComponentModel, System.Collections.Specialized,
  System.Drawing.Design, System.IO, Borland.Data.Web,
  System.Drawing;

type
	[Designer('Borland.Data.Web.DBWebControlDesigner')]
	[ToolboxData('<{0}:DBWebNicerLabel runat=server></{0}:DBWebNicerLabel>')]
  DBWebNicerLabel = class(System.Web.UI.WebControls.WebControl, IPostBackDataHandler, IDBWebColumnLink)
  strict private
    FMyDelegate: &Label;
  strict protected
    // Override Render when descending directly from ASP.NET Control
    // procedure Render(Output: HtmlTextWriter); override;

    // Override RenderContents when descending from ASP.NET WebControl
    procedure RenderContents(Output: HtmlTextWriter); override;
  public
    constructor Create;
  // Implement code from this region for controls that use the DB Web interfaces
  strict protected
    procedure OnInit(e: EventArgs); override;
    procedure OnPreRender(args: EventArgs); override;
    // For more information on IPostBackDataHandler, see the help entry
    // ms-help://borland.bds2/cpref/html/frlrfSystemWebUIIPostBackDataHandlerClassLoadPostDataTopic.htm
    function LoadPostData(postDataKey: string;
      postCollection: NameValueCollection) : boolean;
    procedure RaisePostDataChangedEvent;

  // IDBWebDataLink is the core interface for the DB Web controls
  // and must be implemented for all DB Web controls

  private
    FDataLink: DBWebDataLink;
    FIDataLink: IDBWebDataLink;
    function GetTableName: string;
    procedure SetTableName(Value: string);
    function GetDataSource: IDBDataSource;
    procedure SetDataSource(Value: IDBDataSource);
    function GetText: string;
  protected
    property Text: string read GetText;
  public
    property IDataLink: IDBWebDataLink read FIDataLink;
    procedure DataBind; override;

  published
    [Editor(typeof(Borland.Data.Web.TableNamePropEditor), typeof(UITypeEditor)),
  		LocalizableCategoryAttribute('DBWebControl'),
  		DefaultValue('')]
    property TableName: string read GetTableName write SetTableName;
		[LocalizableCategoryAttribute('DBWebControl'),
  		DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden),
  		DefaultValue('')]
    property DBDataSource: IDBDataSource read GetDataSource write SetDataSource;

  {$REGION 'IDBWebColumnLink declarations'}
  // IDBWebColumnLink is used to databind to a specific column (optional)
  private // Should this be strict private?
    FForeColorEnd: Color;
    FIColumnLink: IDBWebColumnLink;
    function GetIColumnLink : IDBWebColumnLink;
    function GetColumnName: string;
    procedure SetColumnName(Value: string);
  public
    property IColumnLink: IDBWebColumnLink read GetIColumnLink;
  published
    [Editor(typeof(Borland.Data.Web.ColumnNamePropEditor), typeof(UITypeEditor)),
  		LocalizableCategoryAttribute('DBWebControl'),
  		DefaultValue('')]
    property ColumnName: string read GetColumnName write SetColumnName;
  {$ENDREGION}

    property ForeColorEnd: Color read FForeColorEnd write FForeColorEnd;
  end;

implementation

{$REGION 'Control.Render override'}

(*
/// <summary>
/// The override for Render should be used when descending directly from
/// System.Web.UI.WebControls.Control, or when creating a composite control
/// </summary>
/// <param name="output"> The HTML writer to write out to </param>
procedure DBWebNicerLabel.Render(Output: HtmlTextWriter);
begin
  Output.Write(Text);
end;
(**)
{$ENDREGION}

{$REGION 'WebControl.RenderContents override'}
/// <summary>
/// Render this control to the output parameter specified.
/// The override for RenderContents should be used when descending from
/// System.Web.UI.WebControls.WebControl so all cosmetic attributed
/// are rendered appropriately for the control
/// </summary>
/// <param name="output"> The HTML writer to write out to </param>
procedure DBWebNicerLabel.RenderContents(Output: HtmlTextWriter);
type
  Str2 = String[2];
var
  Red,RedD,
  Green,GreenD,
  Blue,BlueD: Integer; // from ForeColor to ForeColorEnd
  Len,i: Integer;
var
  FText: String;

  function Int2Hex(X: Byte): Str2;
  const
    H: array[0..$F] of Char = '0123456789ABCDEF';
  begin
    Result := H[X div $10] + H[X mod $10]
  end;

begin
  FText := Text;
  if FText <> '' then
  begin
    Red := ForeColor.R;
    Green := ForeColor.G;
    Blue := ForeColor.B;
    Len := Length(FText)-1;
    if Len > 0 then
    begin
      RedD := Round((ForeColorEnd.R - ForeColor.R) / Len);
      GreenD := Round((ForeColorEnd.G - ForeColor.G) / Len);
      BlueD := Round((ForeColorEnd.B - ForeColor.B) / Len);
      for i:=1 to Length(FText)-1 do
      begin
        Output.Write('<font color=#' +
          Int2Hex(Red) + Int2Hex(Green) + Int2Hex(Blue) +
          '>' + FText[i] + '</font>');
        Inc(Red,RedD);
        Inc(Green,GreenD);
        Inc(Blue,BlueD)
      end
    end;
    Output.Write('<font color=#' +
      Int2Hex(ForeColorEnd.R) + Int2Hex(ForeColorEnd.G) + Int2Hex(ForeColorEnd.B) +
      '>' + FText[Length(FText)] + '</font>');
  end
end;
{$ENDREGION}

{$REGION 'DB Web control implementation'}
// For all DB web control implementations, the IDBWebDataLink implementation
// region is required. Furthermore, the IDBWebColumnLink region is required
// for components that implement the IDBWebLookupColumnLink.
{$REGION 'IDBWebDataLink implementation'}
/// <summary>
// Construct the required private instance variables, depending on the
// defined options for this control.
/// Use this procedure if IDBWebDataLink interface is implemented
/// </summary>
constructor DBWebNicerLabel.Create;
begin
  inherited;
  FMyDelegate := &Label.Create;
  FDataLink := DBWebColumnLink.Create(self);
  FIColumnLink := (FDataLink as IDBWebColumnLink);
  // Standard DB Web interface should always be defined
  FIDataLink := (FDataLink as IDBWebDataLink);
end;

/// <summary>
/// Override the default initialization method to require postback
/// </summary>
procedure DBWebNicerLabel.OnInit(e: EventArgs);
begin
  inherited OnInit(e);
  if Assigned(Page) then
    Page.RegisterRequiresPostBack(self);
end;

/// <summary>
/// Register control as DBWebControl associated with a specific table
/// </summary>
procedure DBWebNicerLabel.OnPreRender(args: EventArgs);
begin
  inherited OnPreRender(args);
  // You need to register the hidden field to identify the key for
  // read-write controls only. Remove this call if control is read-only.
//  Page.RegisterHiddenField(DBWebDataSource.IdentPrefix + DBWebConst.Splitter
//    + IDataLink.TableName, self.ID);
  DataBind;
end;

function DBWebNicerLabel.GetText: string;
var
  sw: StringWriter;
  tw: HtmlTextWriter;
begin
	sw := StringWriter.Create;
	tw := HtmlTextWriter.Create(sw);
  DataBind();
	FMyDelegate.RenderControl(tw);
	Result := FMyDelegate.Text; // sw.ToString();
end;

// RaisePostDataChangedEvent is called prior to DataBind()
// DataSet and related properties are NOT available here
// Child controls are not available
function DBWebNicerLabel.LoadPostData(postDataKey:string;
  postCollection: NameValueCollection) : boolean;
begin
  FDataLink.LoadPostData(postDataKey, postCollection);
  // set to true if you intend to use RaisePostDataChangedEvent;
  Result := false;
end;

procedure DBWebNicerLabel.RaisePostDataChangedEvent;
begin
  // Put custom data change handling code here
end;

// IDBWebDataLink setters/getters
function DBWebNicerLabel.GetTableName: string;
begin
  Result := FIDataLink.TableName;
end;

procedure DBWebNicerLabel.SetTableName(Value: string);
begin
  FIDataLink.TableName := Value;
end;

function DBWebNicerLabel.GetDataSource: IDBDataSource;
begin
  Result := FIDataLink.DBDataSource;
end;

procedure DBWebNicerLabel.SetDataSource(Value: IDBDataSource);
begin
  FIDataLink.DBDataSource := Value;
end;

procedure DBWebNicerLabel.DataBind;
var
  obj: System.Object;
begin
  try
    // DataBind whatever properties you require wherever you see
    // See the C# source code for DBWebNavigator and DBWebLabeledTextBox
    // for additional examples.

    // Set value to blank if not data bound

    // call to inherited triggers setting of DBDataSource.
		inherited DataBind;
    if FDataLink.IsDataBound then
    begin
      obj := FIColumnLink.DBDataSource.GetColumnValue(Page,
        FIColumnLink.TableName, FIColumnLink.ColumnName);
      if Assigned(obj) then
      begin
			  FMyDelegate.Text := Convert.ToString(obj);
			  inherited DataBind;
      end
    end;
  except
  on E: Exception do
	begin
    if (not ClassUtils.IsDesignTime(Page)) then
				Page.Response.Write(ClassUtils.GetInternalError(Page, FIDataLink, E,
        Self.ID))
    else
		  Raise Exception(E);
  end;
end;

end;
{$ENDREGION}

{$REGION 'IDBWebColumnLink implementation'}
function DBWebNicerLabel.GetIColumnLink : IDBWebColumnLink;
begin
  Result := FIColumnLink; // Could be weak referenced instead
end;

function DBWebNicerLabel.GetColumnName: string;
begin
  Result := IColumnLink.ColumnName;
end;

procedure DBWebNicerLabel.SetColumnName(Value: string);
begin
  IColumnLink.ColumnName := Value;
end;
{$ENDREGION}


{$REGION 'IDBWebLookupColumnLink implementation'}
{$ENDREGION}

{$ENDREGION}


[assembly:TagPrefix('eBob42', 'bob')]

end.

