unit eBob42.ComponentEditors;
interface
uses
  {$IFDEF CLR}
    Borland.Vcl.Design.DesignIntf,
    Borland.Vcl.Design.DesignEditors;
  {$ELSE}
  DesignIntf,  DesignEditors;
  {$ENDIF}

type
  TDataSourceComponentEditor = class(TDefaultEditor)
  public
    function GetVerbCount: Integer; override;
    function GetVerb(Index: Integer): string; override;
    procedure ExecuteVerb(Index: Integer); override;
    procedure Edit; override;
  end;

implementation
uses
  DB, Dialogs, Classes;

{ TDataSourceComponentEditor }

function TDataSourceComponentEditor.GetVerbCount: Integer;
var
  {$IFDEF WIN32}
  Child: TComponent;
  {$ELSE}
  i: Integer;
  {$ENDIF}
begin
  Result := 1; // for the About box...
  if Assigned(Component.Owner) then
  {$IFDEF WIN32}
    for Child in Owner do
      if Child is TDataSet then Inc(Result);
  {$ELSE}
    for i:=0 to Component.Owner.ComponentCount-1 do
      if Component.Owner.Components[i] is TDataSet then Inc(Result)
  {$ENDIF}
end;

function TDataSourceComponentEditor.GetVerb(Index: Integer): string;
var
  {$IFDEF WIN32}
  Child: TComponent;
  {$ELSE}
  i: Integer;
  {$ENDIF}
begin
  if index = 0 then Result := '&About TDataSourceComponentEditor...'
  else
    if Assigned(Component.Owner) then
    {$IFDEF WIN32}
      for Child in Component.Owner do
        if Child is TDataSet then
        begin
          Dec(Index);
          if Index = 0 then
            Result := 'Connect to ' + Child.Name
        end
    {$ELSE}
      for i:=0 to Component.Owner.ComponentCount-1 do
        if Component.Owner.Components[i] is TDataSet then
        begin
          Dec(Index);
          if Index = 0 then
            Result := 'Connect to ' + Component.Owner.Components[i].Name
        end
    {$ENDIF}
end;

procedure TDataSourceComponentEditor.ExecuteVerb(Index: Integer);
var
  {$IFDEF WIN32}
  Child: TComponent;
  {$ELSE}
  i: Integer;
  {$ENDIF}
begin
  if (index = 0) then Edit
  else
    if Assigned(Component.Owner) then
    {$IFDEF WIN32}
      for Child in Component.Owner do
        if Child is TDataSet then
        begin
          Dec(Index);
          if Index = 0 then
          begin
            (Component as TDataSource).DataSet := Child as TDataSet;
            Designer.Modified;
          end
        end
    {$ELSE}
      for i:=0 to Component.Owner.ComponentCount-1 do
        if Component.Owner.Components[i] is TDataSet then
        begin
          Dec(Index);
          if Index = 0 then
          begin
            (Component as TDataSource).DataSet :=
              Component.Owner.Components[i] as TDataSet;
            Designer.Modified;
          end
        end
    {$ENDIF}
end;

procedure TDataSourceComponentEditor.Edit;
begin
  ShowMessage(GetVerb(0));
  inherited
end;

end.
