unit OblongButton;

interface

uses
  SysUtils, Classes, Controls, StdCtrls;

type
  TMultiLineButton = class(TButton)
  strict private
    { Strict private declarations }
    FMultiLine: Boolean;
  protected
    { Protected declarations }
    procedure SetMultiLine(const Value: Boolean);
    procedure CreateParams(var Params: TCreateParams); override;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
  published
    property MultiLine: Boolean read FMultiLine write SetMultiLine default True;
  end;

implementation

uses
  Windows;

{ TMultiLineButton }

constructor TMultiLineButton.Create(AOwner: TComponent);
begin
  inherited;
  FMultiLine := True
end;

procedure TMultiLineButton.CreateParams(var Params: TCreateParams);
begin
  inherited;
  if FMultiLine then
    Params.Style := Params.Style or BS_MULTILINE
  else
    Params.Style := Params.Style and not BS_MULTILINE;
end;

procedure TMultiLineButton.SetMultiLine(const Value: Boolean);
begin
  if Value <> FMultiLine then
  begin
    FMultiLine := Value;
    RecreateWnd
  end;
end;

end.
