unit eBob42.MultiLineButton;
interface
uses
  SysUtils, Classes, Controls, StdCtrls;

type
  TMultiLineButton = class(TButton)
  private
    FMultiLine: Boolean;
    procedure SetMultiLine(const Value: Boolean);
    { Private declarations }
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    { Protected declarations }
  public
    constructor Create(AOwner: TComponent); override;
    { Public declarations }
  published
    { Published declarations }
    property MultiLine: Boolean read FMultiLine write SetMultiLine default True;
  end;

implementation
uses
  Windows;

{ TMultiLineButton }

constructor TMultiLineButton.Create(AOwner: TComponent);
begin
  inherited;
  FMultiLine := True;
end;

procedure TMultiLineButton.CreateParams(var Params: TCreateParams);
begin
  inherited;
  if FMultiLine then
    Params.Style := Params.Style or BS_MULTILINE
  else
    Params.Style := Params.Style and not BS_MULTILINE
end;

procedure TMultiLineButton.SetMultiLine(const Value: Boolean);
begin
  FMultiLine := Value;
  RecreateWnd
end;

end.
